void
genkeypair(PubKey *pk, SecKey *sk, int const L)
{
    mpz_t mpzMaske;

    mpz_init_set_ui(mpzMaske, 1);
    mpz_mul_2exp(mpzMaske, mpzMaske, L);
    mpz_sub_ui(mpzMaske, mpzMaske, 1);

    srandom(time(NULL));
    do {
        mpz_random(pk->p, mpz_size(mpzMaske) + 2);
        mpz_and(pk->p, pk->p, mpzMaske);
        nextstrongprime(pk->p, pk->p);
    }
    while (mpz_sizeinbase(pk->p, 2) != L);
    mpz_set(sk->p, pk->p);

    srandom(time(NULL));
    do {
        do {
            mpz_random(pk->alpha, mpz_size(pk->p));
            mpz_and(pk->alpha, pk->alpha, mpzMaske);
        }
        while (mpz_cmp(pk->alpha, pk->p) > 0);

        mpz_powm_ui(pk->beta, pk->alpha, 2, pk->p);
        if (mpz_cmp_ui(pk->beta, 1) == 0)
            continue;
        mpz_sub_ui(pk->beta, pk->p, 1);
        mpz_tdiv_q_2exp(pk->beta, pk->beta, 1);
        mpz_powm(pk->beta, pk->alpha, pk->beta, pk->p);
    }
    while (mpz_cmp_ui(pk->beta, 1) == 0);

    mpz_sub_ui(pk->beta, pk->p, 2);
    do {
        mpz_random(sk->a, mpz_size(pk->p));
        mpz_and(sk->a, sk->a, mpzMaske);
    }
    while (mpz_cmp(sk->a, pk->beta) > 0);
    mpz_clear(mpzMaske);

    mpz_powm(pk->beta, pk->alpha, sk->a, pk->p);

    return;
}
